#version 330

layout(location=0) in vec3 position; //xyz position
layout(location=1) in vec2 texcoords; //xy texture coords
layout(location=2) in vec3 normal; //xyz normal

uniform mat4 M_mat;
uniform mat4 P_mat;
uniform mat4 V_mat;

out VS_OUT {
    vec3 FragPos;
    vec3 Normal;
    vec2 TexCoords;
	vec4 Position_worldspace;
} vs_out;


/////////////////////////
void main()
{
    vs_out.FragPos = position;
    vs_out.Normal = normal;
    vs_out.TexCoords = texcoords;
	vs_out.Position_worldspace = M_mat * vec4(position, 1.0f);
	gl_Position = P_mat * V_mat * M_mat * vec4(position, 1.0f);
}

