
#version 330 core
layout(location=1) in vec2 uv;
layout(location=0) in vec3 position;
layout(location=2) in vec3 normal;

out vec3 Normal;
out vec3 Position;
out vec2 TexCoords;

uniform mat4 M_mat;
uniform mat4 view;
uniform mat4 projection;

void main()
{
    gl_Position = projection * view * M_mat * vec4(position, 1.0f);
    Normal = mat3(transpose(inverse(M_mat))) * normal;
    Position = vec3(M_mat * vec4(position, 1.0f)).xyz;
    TexCoords = uv;
}
