#version 330 core

layout(location=0) in vec3 position;
layout(location=1) in vec2 uv;
layout(location=2) in vec3 normal;

out vec3 worldNormal;
out vec2 texCoord;

uniform vec4 light_position;
out vec3 LightDirection_cameraspaces;

uniform mat4 P_mat;
uniform mat4 V_mat;
uniform mat4 M_mat;

out vec3 Position_worldspace;
out vec3 Normal_cameraspace;
out vec3 EyeDirection_cameraspace;


void main()
{
	// Pass some variables to the fragment shader
    texCoord = uv;
	
	gl_Position = P_mat * V_mat * M_mat * vec4(position, 1);

	Position_worldspace = (M_mat * vec4(position, 1.0f)).xyz;

	vec3 position_modelspaceCamera = (V_mat * M_mat * vec4(position, 1.0f)).xyz;
    EyeDirection_cameraspace = vec3(0, 0, 0) - position_modelspaceCamera;


	vec3 lightPosition_worldspaceCamera = (V_mat * vec4(light_position.xyz, 1.0f)).xyz;
	LightDirection_cameraspaces = (lightPosition_worldspaceCamera + EyeDirection_cameraspace);
	
    Normal_cameraspace = (V_mat * M_mat * vec4(normal, 0.0f)).xyz;
}

